#version 330

layout (std140) uniform Matrices
{
	mat4 m_pvm;
	mat4 m_view;
	mat4 m_model;
	mat3 m_normal;
	mat4 m_shadow;
};

in vec4 position;	// local space
in vec3 normal;		// local space

out Data
{
	vec3 normal;
	vec4 eye;
	vec4 shadowCoord;
} DataOut;

//----------------------------------------------------------------
// TODO:
// 1) Transform vertex according to the comments.
//----------------------------------------------------------------

void main()
{
	// Transform the vertex from object space to model / world space
	vec4 vertex = m_model * position;

	// Transform the vertex from world space to light / shadow space, save it into shadowCoord
	DataOut.shadowCoord = m_shadow * vertex;

	// Transform the vertex from world space space to camera / view space
	vertex = m_view * vertex;

	// Compute vector to camera
	DataOut.eye = -vertex;

	// Compute view space normal
	DataOut.normal = normalize(m_normal * normal);
 
	// Transform to projection / clip space
	gl_Position = m_pvm * position;
}